<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JPSOAP_DateIntervalsGroups StructType
 * @subpackage Structs
 */
class JPSOAP_DateIntervalsGroups extends AbstractStructBase
{
    /**
     * The Date
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_DateIntervals[]
     */
    public $Date;
    /**
     * Constructor method for JPSOAP_DateIntervalsGroups
     * @uses JPSOAP_DateIntervalsGroups::setDate()
     * @param \StructType\JPSOAP_DateIntervals[] $date
     */
    public function __construct(array $date = array())
    {
        $this
            ->setDate($date);
    }
    /**
     * Get Date value
     * @return \StructType\JPSOAP_DateIntervals[]|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_DateIntervals[] $date
     * @return \StructType\JPSOAP_DateIntervalsGroups
     */
    public function setDate(array $date = array())
    {
        foreach ($date as $jPSOAP_DateIntervalsGroupsDateItem) {
            // validation for constraint: itemType
            if (!$jPSOAP_DateIntervalsGroupsDateItem instanceof \StructType\JPSOAP_DateIntervals) {
                throw new \InvalidArgumentException(sprintf('The Date property can only contain items of \StructType\JPSOAP_DateIntervals, "%s" given', is_object($jPSOAP_DateIntervalsGroupsDateItem) ? get_class($jPSOAP_DateIntervalsGroupsDateItem) : gettype($jPSOAP_DateIntervalsGroupsDateItem)), __LINE__);
            }
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Add item to Date value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_DateIntervals $item
     * @return \StructType\JPSOAP_DateIntervalsGroups
     */
    public function addToDate(\StructType\JPSOAP_DateIntervals $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_DateIntervals) {
            throw new \InvalidArgumentException(sprintf('The Date property can only contain items of \StructType\JPSOAP_DateIntervals, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Date[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JPSOAP_DateIntervalsGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
